<ng-container *ngIf="filtersLoaded | async; else pending">
  <div class="container-xxl min-vh-100">
    <div class="table-responsive">
      <div class="table-wrapper">
        <div class="table-title">
          <div class="row">
            <div class="col-sm-5">
              <label>Show
                <select (change)="onSizeChange($event)" style="box-shadow: none;" class="btn btn-mini btn-light border">
                  <option *ngFor="let size of pageSizes" [ngValue]="size">{{size}}</option>
                </select>
              </label>
              <span>&nbsp;entries</span>
            </div>
            <div class="col-sm-7">
              <button style="float: right" type="button" class="btn btn-success"
                      (click)="modalService.open(addModal, {size: 'lg'})">
                <b>Add user</b>
              </button>
              <div class="search-box">
                <i class="material-icons">&#xE8B6;</i>
                <input type="text" class="form-control" [(ngModel)]="query" placeholder="Search&hellip;">
              </div>
            </div>
          </div>
        </div>
        <table class="table table-bordered table-hover">
          <thead class="thead-dark">
          <tr>
            <th scope="col" [appSort]="users" data-order="desc" data-name="last_name">Name<i class="fa fa-sort"></i>
            </th>
            <th scope="col" [appSort]="users" data-order="desc" data-name="email">Email<i class="fa fa-sort"></i></th>
            <th scope="col" [appSort]="users" data-order="desc" data-name="role">Role<i class="fa fa-sort"></i></th>
            <th scope="col" [appSort]="users" data-order="desc" data-name="main_study">Main study<i
              class="fa fa-sort"></i></th>
            <th scope="col" [appSort]="users" data-order="desc" data-name="student_number">Student number<i
              class="fa fa-sort"></i></th>
            <th scope="col" [appSort]="users" data-order="desc" data-name="teaching_level">Teaching level<i
              class="fa fa-sort"></i></th>
            <th scope="col">Actions</th>
          </tr>
          </thead>
          <tbody>
          <tr
            *ngFor="let user of users | filter : query | slice: (page-1) * pageSize : page * pageSize">
            <td>{{user.full_name}}</td>
            <td> {{user.email}}</td>
            <td>{{user.role}}</td>
            <td>{{user.main_study}}</td>
            <td>{{user.student_number}}</td>
            <td>{{user.teaching_level}}</td>
            <td>
              <div class="btn-group" role="group">
                <button type="button" class="btn btn-primary btn-sm" (click)="openEditModal(editModal, user)">
                  <b>Edit</b>
                </button>
                <button type="button" class="btn btn-danger btn-sm" (click)="openDeleteModal(deleteModal, user)">
                  <b>Delete</b>
                </button>
              </div>
            </td>
          </tr>
          </tbody>
        </table>
        <div style="float: right">
          <ngb-pagination [collectionSize]="collectionSize" [(page)]="page" [boundaryLinks]="true"
                          [pageSize]="pageSize">
            <ng-template ngbPaginationPrevious>Prev</ng-template>
            <ng-template ngbPaginationNext>Next</ng-template>
            <ng-template ngbPaginationFirst>First</ng-template>
            <ng-template ngbPaginationLast>Last</ng-template>
          </ngb-pagination>
        </div>
      </div>
    </div>
  </div>
</ng-container>

<ng-template #pending>
  <div class="loader"></div>
</ng-template>

<!--Add modal-->
<ng-template #addModal let-modal>
  <div class="modal-header">
    <h5 class="modal-title">Add user</h5>
    <button type="button" class="close" (click)="modal.close()" aria-label="Close"><span
      aria-hidden="true">&times;</span></button>
  </div>
  <form [formGroup]="addUserForm" (ngSubmit)="onSubmitAdd()">
    <div class="modal-body">
      <div class="form-row">
        <div class="form-group col-8">
          <label for="email_1">Email</label>
          <input type="email" class="form-control" placeholder="Email" formControlName="email" id="email_1" required>
        </div>
        <div class="form-group col-4">
          <label for="role_1">Role</label>
          <select class="form-control" formControlName="role" id="role_1" required>
            <option value="member">Member</option>
            <option value="admin">Admin</option>
          </select>
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-5">
          <label for="first_name_1">First name</label>
          <input type="text" class="form-control" placeholder="First name" formControlName="first_name"
                 id="first_name_1" required>
        </div>
        <div class="form-group col-2">
          <label for="initials_1">Initials</label>
          <input type="text" class="form-control" placeholder="Initials" formControlName="initials" id="initials_1"
                 required>
        </div>
        <div class="form-group col-5">
          <label for="last_name_1">Last name</label>
          <input type="text" class="form-control" placeholder="Last name" formControlName="last_name" id="last_name_1"
                 required>
        </div>
      </div>
      <div class="form-group"><label for="date_of_birth_1">Date of birth</label>
        <input type="date" class="form-control" formControlName="date_of_birth" id="date_of_birth_1" required>
      </div>
      <hr>
      <div class="form-row">
        <div class="form-group col-2">
          <label for="main_study_1">Main study</label>
          <input type="text" class="form-control" placeholder="Main study" formControlName="main_study"
                 id="main_study_1" required>
        </div>
        <div class="form-group col-4">
          <label for="student_number_1">Student number</label>
          <input type="text" class="form-control" placeholder="Student number" formControlName="student_number"
                 id="student_number_1" required>
        </div>
        <div class="form-group col-6">
          <label for="phone_number_1">Phone number</label>
          <input type="text" class="form-control" placeholder="Phone number" formControlName="phone_number"
                 id="phone_number_1" required>
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-6">
          <label for="address_1">Street address</label>
          <input type="text" class="form-control" placeholder="Street address" formControlName="address" id="address_1"
                 required>
        </div>
        <div class="form-group col-2">
          <label for="postal_code_1">Postal code</label>
          <input type="text" class="form-control" placeholder="Postal code" formControlName="postal_code"
                 id="postal_code_1" required>
        </div>
        <div class="form-group col-4">
          <label for="city_1">City</label>
          <input type="text" class="form-control" placeholder="City" formControlName="city" id="city_1" required>
        </div>
      </div>
      <div class="form-group">
        <label for="iban_1">IBAN</label>
        <input type="text" class="form-control" placeholder="IBAN" formControlName="iban" id="iban_1" required>
      </div>
      <hr>
      <div class="form-row">
        <div class="form-group col-6">
          <label for="teaching_level_1">Teaching level</label>
          <select class="form-control" formControlName="teaching_level" id="teaching_level_1" required>
            <option value="" selected>Choose...</option>
            <option value="minor">Minor</option>
            <option value="master">Master</option>
            <option value="external">External</option>
          </select>
        </div>
        <div class="form-group col-6">
          <label for="teaching_area_1">Teaching area</label>
          <input type="text" class="form-control" placeholder="Teaching area" formControlName="teaching_area"
                 id="teaching_area_1" required>
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-6">
          <label for="committee_1">Committee</label>
          <select class="form-control" formControlName="committee" multiple="multiple" id="committee_1">
            <option value="OLC">OLC</option>
            <option value="KFC">KFC</option>
            <option value="Kascommissie">Kascommissie</option>
            <option value="Raad van Advies">Raad van Advies</option>
            <option value="OproepCie">OproepCie</option>
          </select>
        </div>
        <div class="form-group col-6">
          <label for="member_since_1">Member since</label>
          <input type="date" class="form-control" formControlName="member_since" id="member_since_1" required>
        </div>
      </div>
      <hr>
      <div class="form-row">
        <div class="form-group col-5">
          <label for="payment_auth_membership_1">Payment authorization membership</label>
          <div id="payment_auth_membership_1">
            <div class="form-check form-check-inline">
              <label class="radio-inline">
                <input name="payment_auth_membership" class="form-check-input" type="radio" value="yes"
                       formControlName="payment_auth_membership">Yes</label>
            </div>
            <div class="form-check form-check-inline">
              <label class="radio-inline">
                <input name="payment_auth_membership" class="form-check-input" type="radio" value="no"
                       formControlName="payment_auth_membership">No</label>
            </div>
          </div>
        </div>
        <div class="form-group col-4">
          <label for="payment_auth_activities_1">Payment authorization activities</label>
          <div id="payment_auth_activities_1">
            <div class="form-check form-check-inline">
              <label class="radio-inline">
                <input name="payment_auth_activities" class="form-check-input" type="radio" value="yes"
                       formControlName="payment_auth_activities">Yes</label>
            </div>
            <div class="form-check form-check-inline">
              <label class="radio-inline">
                <input name="payment_auth_activities" class="form-check-input" type="radio" value="no"
                       formControlName="payment_auth_activities">No</label>
            </div>
          </div>
        </div>
        <div class="form-group col-3">
          <label for="payment_characteristic_1">Payment characteristic</label>
          <input type="text" class="form-control" placeholder="Payment characteristic"
                 formControlName="payment_characteristic" id="payment_characteristic_1" required>
        </div>
      </div>
      <div class="form-group">
        <label for="comments_1">Comments</label>
        <textarea class="form-control" placeholder="Comments" formControlName="comments" id="comments_1" required>
        </textarea>
      </div>
      <div class="form-row">
        <div class="form-group col-4">
          <label for="contribution_1">Contribution</label>
          <input type="number" class="form-control" placeholder="Contribution" formControlName="contribution"
                 id="contribution_1" required>
        </div>
        <div class="form-group col-5">
          <label for="mandate_1">Mandate</label>
          <input type="text" class="form-control" placeholder="Mandate" formControlName="mandate" id="mandate_1"
                 required>
        </div>
        <div class="form-group col-3">
          <label for="used_for_1">Use</label>
          <input type="text" value="RCUR" class="form-control" placeholder="RCUR" formControlName="used_for"
                 id="used_for_1" readonly>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="button" class="btn btn-secondary" (click)="modal.dismiss()">Cancel</button>
      <button type="submit" class="btn btn-primary">Save</button>
    </div>
  </form>
</ng-template>


<!--Edit modal-->
<ng-template #editModal let-modal>
  <div class="modal-header">
    <h5 class="modal-title">Edit user</h5>
    <button type="button" class="close" (click)="modal.close()" aria-label="Cloes"><span
      aria-hidden="true">&times;</span></button>
  </div>
  <form [formGroup]="editUserForm" (ngSubmit)="onSubmitEdit()">
    <div class="modal-body">
      <div class="form-row">
        <div class="form-group col-8">
          <label for="email_2">Email</label>
          <input type="email" class="form-control" placeholder="Email" formControlName="email" id="email_2" required>
        </div>
        <div class="form-group col-4">
          <label for="role_2">Role</label>
          <select class="form-control" formControlName="role" id="role_2" required>
            <option value="member">Member</option>
            <option value="admin">Admin</option>
          </select>
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-5">
          <label for="first_name_2">First name</label>
          <input type="text" class="form-control" placeholder="First name" formControlName="first_name"
                 id="first_name_2" required>
        </div>
        <div class="form-group col-2">
          <label for="initials_2">Initials</label>
          <input type="text" class="form-control" placeholder="Initials" formControlName="initials" id="initials_2"
                 required>
        </div>
        <div class="form-group col-5">
          <label for="last_name_2">Last name</label>
          <input type="text" class="form-control" placeholder="Last name" formControlName="last_name" id="last_name_2"
                 required>
        </div>
      </div>
      <div class="form-group"><label for="date_of_birth_2">Date of birth</label>
        <input type="date" class="form-control" formControlName="date_of_birth" id="date_of_birth_2" required>
      </div>
      <hr>
      <div class="form-row">
        <div class="form-group col-2">
          <label for="main_study_2">Main study</label>
          <input type="text" class="form-control" placeholder="Main study" formControlName="main_study"
                 id="main_study_2" required>
        </div>
        <div class="form-group col-4">
          <label for="student_number_2">Student number</label>
          <input type="text" class="form-control" placeholder="Student number" formControlName="student_number"
                 id="student_number_2" required>
        </div>
        <div class="form-group col-6">
          <label for="phone_number_2">Phone number</label>
          <input type="text" class="form-control" placeholder="Phone number" formControlName="phone_number"
                 id="phone_number_2" required>
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-6">
          <label for="address_2">Street address</label>
          <input type="text" class="form-control" placeholder="Street address" formControlName="address" id="address_2"
                 required>
        </div>
        <div class="form-group col-2">
          <label for="postal_code_2">Postal code</label>
          <input type="text" class="form-control" placeholder="Postal code" formControlName="postal_code"
                 id="postal_code_2" required>
        </div>
        <div class="form-group col-4">
          <label for="city_2">City</label>
          <input type="text" class="form-control" placeholder="City" formControlName="city" id="city_2" required>
        </div>
      </div>
      <div class="form-group">
        <label for="iban_2">IBAN</label>
        <input type="text" class="form-control" placeholder="IBAN" formControlName="iban" id="iban_2" required>
      </div>
      <hr>
      <div class="form-row">
        <div class="form-group col-6">
          <label for="teaching_level_2">Teaching level</label>
          <select class="form-control" formControlName="teaching_level" id="teaching_level_2" required>
            <option value="minor">Minor</option>
            <option value="master">Master</option>
            <option value="external">External</option>
          </select>
        </div>
        <div class="form-group col-6">
          <label for="teaching_area_2">Teaching area</label>
          <input type="text" class="form-control" placeholder="Teaching area" formControlName="teaching_area"
                 id="teaching_area_2" required>
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-6">
          <label for="committee_2">Committee</label>
          <select class="form-control" formControlName="committee" multiple="multiple" id="committee_2">
            <option value="OLC">OLC</option>
            <option value="KFC">KFC</option>
            <option value="Kascommissie">Kascommissie</option>
            <option value="Raad van Advies">Raad van Advies</option>
            <option value="OproepCie">OproepCie</option>
          </select>
        </div>
        <div class="form-group col-6">
          <label for="member_since_2">Member since</label>
          <input type="date" class="form-control" formControlName="member_since" id="member_since_2" required>
        </div>
      </div>
      <hr>
      <div class="form-row">
        <div class="form-group col-5">
          <label for="payment_auth_membership_2">Payment authorization membership</label>
          <div id="payment_auth_membership_2">
            <div class="form-check form-check-inline">
              <label class="radio-inline">
                <input name="payment_auth_membership" class="form-check-input" type="radio" value="yes"
                       formControlName="payment_auth_membership">Yes</label>
            </div>
            <div class="form-check form-check-inline">
              <label class="radio-inline">
                <input name="payment_auth_membership" class="form-check-input" type="radio" value="no"
                       formControlName="payment_auth_membership">No</label>
            </div>
          </div>
        </div>
        <div class="form-group col-4">
          <label for="payment_auth_activities_2">Payment authorization activities</label>
          <div id="payment_auth_activities_2">
            <div class="form-check form-check-inline">
              <label class="radio-inline">
                <input name="payment_auth_activities" class="form-check-input" type="radio" value="yes"
                       formControlName="payment_auth_activities">Yes</label>
            </div>
            <div class="form-check form-check-inline">
              <label class="radio-inline">
                <input name="payment_auth_activities" class="form-check-input" type="radio" value="no"
                       formControlName="payment_auth_activities">No</label>
            </div>
          </div>
        </div>
        <div class="form-group col-3">
          <label for="payment_characteristic_2">Payment characteristic</label>
          <input type="text" class="form-control" placeholder="Payment characteristic"
                 formControlName="payment_characteristic" id="payment_characteristic_2" required>
        </div>
      </div>
      <div class="form-group">
        <label for="comments_2">Comments</label>
        <textarea class="form-control" placeholder="Comments" formControlName="comments" id="comments_2" required>
        </textarea>
      </div>
      <div class="form-row">
        <div class="form-group col-4">
          <label for="contribution_2">Contribution</label>
          <input type="number" class="form-control" placeholder="Contribution" formControlName="contribution"
                 id="contribution_2" required>
        </div>
        <div class="form-group col-5">
          <label for="mandate_2">Mandate</label>
          <input type="text" class="form-control" placeholder="Mandate" formControlName="mandate" id="mandate_2"
                 required>
        </div>
        <div class="form-group col-3">
          <label for="used_for_2">Use</label>
          <input type="text" value="RCUR" class="form-control" placeholder="RCUR" formControlName="used_for"
                 id="used_for_2" readonly>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="button" class="btn btn-secondary" (click)="modal.dismiss()">Cancel</button>
      <button type="submit" class="btn btn-primary">Save</button>
    </div>
  </form>
</ng-template>


<!--Delete modal-->
<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h5 class="modal-title">Delete user</h5>
    <button type="button" class="close" (click)="modal.dismiss()" aria-label="Close">
      <span aria-hidden="true">&times;</span></button>
  </div>
  <form [formGroup]="deleteUserForm" (ngSubmit)="onSubmitDelete()">
    <div class="modal-body">
      <div class="form-group row">
        <label class="col-sm-4 col-form-label" for="email_3">Email:</label>
        <div class="col-sm-8">
          <input type="email" formControlName="email" class="form-control-plaintext" id="email_3" readonly>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-4 col-form-label" for="full_name_3">Name:</label>
        <div class="col-sm-8">
          <input type="text" formControlName="full_name" class="form-control-plaintext" id="full_name_3" readonly>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="button" class="btn btn-secondary" (click)="modal.dismiss()">Cancel</button>
      <button type="submit" class="btn btn-danger">Delete</button>
    </div>
  </form>
</ng-template>
